EC2 IAM Role should be a VM setting rather than image setting
Description

Setting the IAM role as an attribute of the "image" means that you can only have "one" role. If you want to separate your "staging"

from your "production" roles (for example), you have to use a different AMI because you cannot have two images with the same AMI.

Also, you cannot "set" the value at host creation time. You can only chose an OS image, which has it attached, which is fairly limiting.

http://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_use_switch-role-ec2.html

.. this may involve "instance profiles" -- 

http://docs.aws.amazon.com/IAM/latest/UserGuide/id_roles_use_switch-role-ec2_instance-profiles.html

~tommy

Related issues:

Related to Foreman - Feature #17286: using IAM role when querying AWS API Closed

History

#1 - 08/19/2016 02:02 AM - Daniel Lobato Garcia

- Tracker changed from Bug to Feature

#2 - 08/19/2016 02:49 AM - Dominic Cleal

- Category set to Compute resources - EC2

#3 - 11/09/2016 06:20 AM - Dominic Cleal

- Related to Feature #17286: using IAM role when querying AWS API added

#4 - 09/17/2018 03:39 PM - Tommy McNeely

I was asked to clarify this request. It has been a couple years since I filed it, but here is my best recollection...

We have a customer using IAM Roles, which assign dynamic IAM credentials to machines rather than having to manually create credentials and copy

and paste them into a configuration.

The IAM Role setting is currently configured at the image level, which means where you associate the os version to the ami-xxxxxxxx ID. This setting

needs to be configurable at the instance level instead of image level. I don't have a problem with being able to set a "default" IAM role at the image

level, for a shop with low security requirements, but we cannot have the same role assigned to all instances.

#5 - 07/15/2021 09:19 AM - Amir Fefer

- Status changed from New to Closed

This won't be implemented any time soon, If it still relevant please reopen this.
